'freebasic
'(C) Dmitriy Korabelnikov 2019
'e-mail: d_korabelnikov@mail.ru

deflng a-z
const sqsiz=320
const bord=70
dim  shared state as long

'Starting code
'Don't forget to edit file simpwrite.ini for COM port number and speed
sub setup() 
screenres sqsiz,sqsiz,32
'param$ = "COM15:9600,N,8,1,CD,CS,DS,OP,BIN"
param2$ = ",N,8,1,CD,CS,DS,OP,BIN"
open exepath+"\simpwrite.ini" for input as #2:line input #2,param1$:close #2
param$=param1$+param2$
e=open com (param$, as #1)
if e<>0 then
    print " Error opening "+mid$(param$,1,instr(param$,":"))
    print " Check simpwrite.ini"
    print " for COM port number and speed"
    print " Check Arduino connection"
    sleep 10000:end
end if
end sub

'Returns TRUE if x,y in the central square
function mouseOverRect(x as long,y as long) as long
  mouseOverRect=((X>bord) and (X<sqsiz-bord) and (Y>bord) and (Y<sqsiz-bord))
end function

'Program main loop code
sub redraw()
dim  col as unsigned long
getmouse mx,my
if mouseOverRect(mx,my) then
    col=rgb(0,128,0)
    if state<>1 then
'Send a string to Arduino
'In the simplest case Arduino understands only "H" and "L" (and blinks by LED)
'String also can be displayed on LCD display attached to Arduino 
    state=1:print #1,string$(4,8);"High";
    end if
else                         
    col=rgb(64,64,64)
    if  state<>0 then
'Send a string to Arduino
    state=0:print #1,string$(4,8);"Low";
    end if
end if
line(bord, bord)-(sqsiz-bord, sqsiz-bord),col,"BF"
line(bord, bord)-(sqsiz-bord, sqsiz-bord),rgb(255,255,255),"B"
'Exit from program if any key pressed
if inkey$<>"" then
  close #1:end
end if
'Delay 100 milliseconds
sleep 100
end sub

' main
setup()
while 1:redraw():wend

