 // Wiring/Arduino code:
 // Read data from the serial and turn ON or OFF a light depending on the value
 
 char val; // Data received from the serial port
 int ledPin = LED_BUILTIN; // Set the pin to onboard LED
 
 void setup() {
 pinMode(ledPin, OUTPUT); // Set pin as OUTPUT
 Serial.begin(9600); // Start serial communication at 9600 bps
 }
 
 void loop() {
 while (Serial.available()) { // If data is available to read,
    val = Serial.read(); // read it and store it in val
    // If H was received turn the LED on
    if      (val == 'H') digitalWrite(ledPin, HIGH);
    // If L was received turn it OFF
    else if (val == 'L') digitalWrite(ledPin, LOW);
    else /*nothing*/;
 }
 delay(100); // Wait 100 milliseconds for next reading
 }
 
